@extends('utility.layout', [
    'title' => 'Confirm Password',
    'orgname' => hs_setting('cHD_ORGNAME'),
    'theme' => 'utility',
])

@section('scripts_styles_includes')
    @include('shared.scripts_styles', [
        'debug' => config('app.debug'),
        'static_direct' => defined('STATIC_DIRECT'),
        'base_url' => cHOST,
        'version' => instHSVersion,
    ])
@endsection

@section('body')
    <form method="post" action="{{ route('two-factor.login') }}" name="loginform">
        @csrf
        <a href="https://www.helpspot.com" class="logo" target="_blank"><img src="{{ static_url() }}/static/img5/helpspot-logo-color.svg" width="200" border="0" /></a>

        <div id="auth-box">
            <div class="title">{{ hs_setting('cHD_ORGNAME') }}</div>
            <div class="title-line"></div>
            <div class="auth-body">
                @if (session('status'))
                    <div class="hsnotificationbox hderrorbox">{{ session('status') }}</div>
                @endif
                <div class="input-wrap clearfix" id="token">
                    <input type="text" name="code" id="code" autocomplete="off" spellcheck="false" placeholder="Two Factor Auth Token" value="" />
                    <span class="mt-2 text-gray-500 text-xs">Don't have access to your Two Factor token? Click <a href="#" id="forgot">here</a> to use a recovery code instead.</span>
                </div>
                <div class="input-wrap clearfix" id="backup" style="display:none;">
                    <input type="text" name="recovery_code" id="recovery_code" autocomplete="off" spellcheck="false" placeholder="Recovery Code" value="" />
                </div>
                <div class="input-wrap clearfix">
                    <button type="submit" class="btn accent auth-button">Login</button>
                </div>
            </div>
        </div>
    </form>
    <script type="text/javascript" language="JavaScript" nonce="{{ csp_nonce() }}">
        jQuery( document ).ready(function( $ ) {
                $("#forgot").on("click", function(e) {
                e.preventDefault();
                $("#token").hide();
                $("#backup").show();
            });
        });
    </script>
@endsection
